/**
   @file Plugin.cpp
 
    Plugin entry points
 
 	@author Tomaso Paoletti <tpaoletti@users.sourceforge.net>
 
 	Based on Translator sample plugin by John R. Dance, 1999
 	
   This software is distributed under the GNU Public License.  
   See section COPYING of the GNU Public license
   for conditions under which this file may be redistributed.
*/

#include "PlugInPreferences.h"

#include "JavaPlugin.h"
#include "JavaPluginPrefs.h"

#include "stdio.h"

// ---- exported plug-in functions -------------------------------------------
#define EXPORT __declspec(dllexport)
#pragma export on
extern "C" {
EXPORT status_t MakeAddOnView(int32 inIndex, BRect inRect, MPlugInPrefsView*& ouView);
EXPORT status_t MakeAddOnBuilder(int32 inIndex, MPlugInBuilder*& outBuilder);
EXPORT status_t MakeAddOnLinker(MPlugInLinker*& outLinker);
}
#pragma export reset

// ---------------------------------------------------------------------------

extern "C"
status_t
MakeAddOnView(int32 inIndex, BRect inRect, MPlugInPrefsView*& outView)
{
	long result = B_ERROR;

	switch (inIndex) {
		case 0:
			outView = new JavaPluginPrefs(inRect, "javaPrefs", 0, 0);
			result = B_OK;
			break;
	}

	return result;
}

// ---------------------------------------------------------------------------

extern "C"
status_t
MakeAddOnBuilder(int32 inIndex, MPlugInBuilder*& outBuilder)
{
	long result = B_ERROR;

	switch (inIndex) {
		case 0:
			outBuilder = new JavaPlugin();
			result = B_OK;
			break;
	}

	return result;
}

// ---------------------------------------------------------------------------

extern "C"
status_t
MakeAddOnLinker(MPlugInLinker*& outLinker)
{
	// generic translations do not involve linking
	return B_ERROR;	
}

