/**
 * @file lbl.cpp 
 * Static text
 *
 * Copyright (c) 1998-2000
 *      Transvirtual Technologies, Inc.  All rights reserved.
 *
 * @author T. Paoletti <tpaoletti@users.sourceforge.net>,
 *         <your name here>
 *
 * See the file "license.terms" for information on usage and redistribution 
 * of this file. 
 */

#include "toolkit.hpp"

/** 
	Native widget for static text labels 
*/
class KLabel:public KWnd {
public:		
	KLabel( BView * parent, char* lbl) {
		BRect r(0,0,100,20);	// !!!
		BView * v = new BStringView(r, "KLabel", lbl);
		
		setView(v);
		parent->AddChild(v);
	}

	BStringView *	NATIVE() {
		return (BStringView *)getView();
	}
	
	void KLabel::setJustify( int adjust) {
UNIMPLEMENTED((
		int style = GetWindowLong( hwnd, GWL_STYLE);
		switch( adjust) {
		case 0:	//left
			style &= ~(SS_CENTER | SS_RIGHT);
			style |= SS_LEFT;
			break;
		case 1:	//center

			style &= ~(SS_LEFT | SS_RIGHT);

			style |= SS_CENTER;

			break;

		case 2:	//right
			style &= ~(SS_CENTER | SS_LEFT);
			style |= SS_RIGHT;
			break;
		}
		
		SetWindowLong( hwnd, GWL_STYLE, style);
));
	}
	
	void KLabel::setText( jstring text) {
		if (lock()) {
			if ( text) {
				NATIVE()->SetText( java2CString( JniEnv, X, text));
			}
			else {
				NATIVE()->SetText( "");
			}
			unlock();
		}
	}

	char* KLabel::getText() {
		char * txt = NULL;
		if (lock()) {
			txt = (char *)NATIVE()->Text();
			unlock();
		}
		return txt; 
	}

};



/*************************
*	exported functions
**************************/
extern "C" {
	
	void* __cdecl
		Java_java_awt_Toolkit_lblCreateLabel ( JNIEnv* env, jclass clazz, KWnd* parent, jstring label )
	{
		return ( new KLabel( parent->getView(), java2CString( env, X, label) ));
	}
	
	void __cdecl
		Java_java_awt_Toolkit_lblSetText ( JNIEnv* env, jclass clazz, KLabel* wnd, jstring label)
	{
		wnd->setText( label);
	}
	
	void __cdecl
		Java_java_awt_Toolkit_lblSetJustify ( JNIEnv* env, jclass clazz, KLabel* wnd, jint adjust )
	{
		wnd->setJustify( adjust);
	}
	
}
