/**
 * @file widget.cpp 
 * Generic widget class used for canvas and panel
 *
 * Copyright (c) 1998-2000
 *      Transvirtual Technologies, Inc.  All rights reserved.
 *
 * @author T. Paoletti <tpaoletti@users.sourceforge.net>,
 *         <your name here>
 *
 * See the file "license.terms" for information on usage and redistribution 
 * of this file. 
 */
 
#include "toolkit.hpp"

/**
   A generic widget for canvas and panels.
*/
class KWidget:public KWnd {
	public:		
		KWidget( BView * parent) {
			BView * v = new BView(BRect(0,0,0,0), "KWidget", B_FOLLOW_ALL_SIDES, B_WILL_DRAW);
			v->SetViewColor(B_TRANSPARENT_COLOR);
			v->Show();
			
			parent->AddChild(v);
			setView(v);
			DBG(AWT, ("new KWidget %p (parent %p)\n", v, parent)); 
		}
	
	bool KWidget::OnPaint( int x, int y, int width, int height){
		DBG(AWT, ("KWidget::OnPaint %d,%d %d,%d\n", x,y,width,height));
/* !!! 
		PAINTSTRUCT ps;
		HDC hdc;

		hdc = BeginPaint( hwnd, &ps);

		if ( ps.fErase )
			FillRect( ps.hdc, &ps.rcPaint, brush);

		EndPaint( hwnd, &ps);
*/
		/** @todo REVIEW BACKGROUND ERASURE */
		//if (erase) 
		if (lock()) {
UNIMPLEMENTED((
// !!!			getView()->FillRect( BRect(x,y,x+width,y+height));
));
			/** @todo remove debug StrokeRect */
			getView()->StrokeRect( BRect(x,y,x+width,y+height));	
			unlock();
		}

		X->jEvt = JniEnv->CallStaticObjectMethod( PaintEvent, getPaintEvent,
							srcIdx, PAINT, x, y, width, height );			
		
		return true;
	}

	};


	
	/*************************
	*	exported functions
	**************************/
extern "C" {

	void* __cdecl
		Java_java_awt_Toolkit_widgetCreateWidget ( JNIEnv* env, jclass clazz, KWnd* parent)
	{
		return ( new KWidget( parent->getView() ));
	}

}
