/* jwindow.h 


	(c) Copyright 1999 Sim IJskes

*/

#include <InterfaceKit.h>

static const int NULL_EVENT = 0 ;
static const int UPDATE = 801 ;

static const int WINDOW_FIRST = 200;
static const int WINDOW_OPENED = 200;
static const int WINDOW_CLOSING = 201;
static const int WINDOW_CLOSED = 202;
static const int WINDOW_ICONIFIED = 203;
static const int WINDOW_DEICONIFIED = 204;
static const int WINDOW_ACTIVATED = 205;
static const int WINDOW_DEACTIVATED = 206;
static const int WINDOW_LAST = 206;

static const int COMPONENT_FIRST = 100;
static const int COMPONENT_MOVED = 100;
static const int COMPONENT_RESIZED = 101;
static const int COMPONENT_SHOWN = 102;
static const int COMPONENT_HIDDEN = 103;
static const int COMPONENT_LAST = 103;

static const int MOUSE_FIRST = 501;
static const int MOUSE_DOWN = 501;
static const int MOUSE_UP = 502;
static const int MOUSE_MOVE = 503;
static const int MOUSE_ENTER = 504;
static const int MOUSE_EXIT = 505;
static const int MOUSE_DRAG = 506;
static const int MOUSE_LAST = 506;

static const int KEY_FIRST = 401;
static const int KEY_PRESS = 401;
static const int KEY_RELEASE = 402;
static const int KEY_ACTION = 403;
static const int KEY_ACTION_RELEASE = 404;
static const int KEY_LAST = 404;

static const int FOCUS_FIRST = 1001; //TODO

static const int FOCUS_GAINED = 1004;
static const int FOCUS_LOST = 1005;

static const int FOCUS_LAST = 1009; //TODO

class JavaWindow : public BWindow
{
public:
	JavaWindow(BRect frame, const char *title, window_type type, 
			uint32 flags, uint32 workspaces = B_CURRENT_WORKSPACE);

	virtual ~JavaWindow();

	/////////////////////////////////////
	// Bwindow overrides

	virtual void FrameResized(float width, float height);
	virtual void WindowActivated(bool active);
	virtual void FrameMoved(BPoint screenPoint);
	virtual void Minimize(bool minimize);

	virtual void DispatchMessage(BMessage *message, BHandler *target);
	virtual bool QuitRequested(void);

	// Bwindow overrides
	/////////////////////////////////////

	/////////////////////////////////////
	// wnd support methods

	void SetResizable( bool sw );
	void SetBounds( int x, int y, int w, int h );
	void SetVisible( bool sw );
	void SetParent( BWindow *wnd );

	// wnd support methods
	/////////////////////////////////////

private:
	void Event( int evt );
	void MsgEvent( int evtId, BMessage *msg );  
	void MouseMovedEvent( BMessage *msg );  
};

